<# PowerShell Make Mobi (convert epubs to mobi)
Note that you need to install Powershell before this is useful - 
Google it, it's all over the www

What this script does:

Line 34-41:	defines a function to select your directory. It is invoked in 
			Line 42 (should pop up a directory picker, then set current directory)

Line 45: 	defines the path to your Calibre location's ebook-convert.exe 
          	file (used on line 24)

Line 46: 	lists the arguments to pass to ebook-convert.exe (these vary 
          	depending on your preferences and the conversion type)

Line 48: 	Gets a list of all the target files in the target directory 
          	(and its subfolders) - change the filter to start with 
			another file type

Line 50: 	Replaces the extension FROM one file type TO another

Line 51: 	un-comment if you want to see which files are found, and that 
          	you're going to process (and comment the next line to just do a 
		  	"what-if" scenario)

Line 52: 	Does the actual processing - calls ebook-convert.exe (with a 
          	fully qualified path), then feeds it the quoted full path of 
		  	the ebook, followed by the full path to the converted ebook, 
		  	followed by the arguments in line 66. The book is saved in 
			the directory that the source file is found in

Script v1.0: written by Mark Wallace (contact me at WebCastle.com)			
#>
function Select-Folder($message='Select the folder that your epub files are in.', $path = 0) { 
     $object = New-Object -comObject Shell.Application  
      
     $folder = $object.BrowseForFolder(0, $message, 0, $path) 
     if ($folder -ne $null) { 
         $folder.self.Path 
     } 
 } 

Clear Host
$Path = Select-Folder ; set-location $Path
$CalibreCommand="C:\PROGRA~1\Calibre2\ebook-convert.exe"
$CalibreArgs = "--mobi-ignore-margins --no-inline-toc --smarten-punctuation --line-height=14 --base-font-size=12 --margin-top=5 --margin-left=5 --margin-right=5 --margin-bottom=5"
$Path = $PWD
	Get-ChildItem $Path -Recurse -filter  "*.epub" | Foreach {
		$FN_In = $_.FullName
		$FN_Out = $FN_In.Replace(".epub", ".mobi")
			# Write-Host "$CalibreCommand `"$FN_In`" `"$FN_Out`" $CalibreArgs" `n `r `n `r
			Invoke-Expression "$CalibreCommand `"$FN_In`" `"$FN_Out`" $CalibreArgs"
}

<# Obviously there are still things to do - I'd like to implement a progress bar, 
count the files and estimate the time and give you the option to abort (each file 
convert takes about a minute on my system - if you're doing 600 files, that's 10 hours.
I also can give you the option to recurse or not (this script just assumes tp recurse 
- if you don't, then pick a bottom level directory or move your files). It might also be 
useful to allow the user to move the new files to a different directory (currently 
they're saved in the same dir as the originals) and to give the option to move, delete 
or archive the originals if the conversion runs without errors. Given enough time, I 
can also figure out the various command line args that Calibre needs and give the user 
the choice of which formats to convert between.
#>


